Unit taig3r_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, UtRes_p, AIG3R_p;

function taig3r: String; 

implementation

function taig3r: String;
var
J,I,JI,JJ,II,IERR,M,N,K :Integer;
RCOND :Real;
B :Array [0..15] of Real;
C :Array [0..15] of Real;
Z :Array [0..3] of Real;
NLEAD :Array [0..3] of Integer;
const
A :Array [0..15] of Real = ( 7.9,8.5,4.3,3.2,5.6,-4.8,4.2,-1.4,5.7,0.8,-3.2,
-8.9,-7.2,3.5,9.3,3.3 );
label
_1,_2,_3,_4,_5,_6,_7,_8;
begin
Result := '';
M := 4;
N := M;
for I:=1 to M do
 begin
  for J:=1 to N do
   begin
    B[(I-1)+(J-1)*4] := A[(I-1)+(J-1)*4];
_1:
   end;
_2:
 end;
Result := Result + Format('%s',[' A=']);
Result := Result + #$0D#$0A;
for J:=1 to N do
 begin
for I:=1 to M do
 begin
  Result := Result + Format('%20.12f ',[A[(I-1)+(J-1)*4]]) + #$0D#$0A;
 end;
 end;
Result := Result + #$0D#$0A;
AIG3R(A,M,N,NLEAD,RCOND,Z,IERR);
Result := Result + Format('%s',['   NLEAD=']);
Result := Result + #$0D#$0A;
for JI:=1 to N do
 begin
  Result := Result + Format('%3d ',[NLEAD[JI-1]]) + #$0D#$0A;
 end;
Result := Result + #$0D#$0A;
Result := Result + Format('%s',[' A=']);
Result := Result + #$0D#$0A;
for JJ:=1 to N do
 begin
for II:=1 to M do
 begin
  Result := Result + Format('%20.12f ',[A[(II-1)+(JJ-1)*4]]) + #$0D#$0A;
 end;
 end;
Result := Result + #$0D#$0A;
Result := Result + Format('%s',['   IERR=']);
Result := Result + Format('%3d',[IERR]) + #$0D#$0A;
Result := Result + Format('%s',['   RCOND=']);
Result := Result + Format('%20.12f ',[RCOND]) + #$0D#$0A;
for I:=1 to M do
 begin
  for J:=1 to N do
   begin
    C[(I-1)+(J-1)*4] := 0.0;
    for K:=1 to N do
     begin
      C[(I-1)+(J-1)*4] := C[(I-1)+(J-1)*4]+B[(I-1)+(K-1)*4]*A[(K-1)+(J-1)*4];
_3:
     end;
_4:
   end;
_5:
 end;
Result := Result + Format('%s',[' A*INVERSE(A)=']);
Result := Result + #$0D#$0A;
for J:=1 to N do
 begin
for I:=1 to M do
 begin
  Result := Result + Format('%20.12f ',[C[(I-1)+(J-1)*4]]) + #$0D#$0A;
 end;
 end;
Result := Result + #$0D#$0A;
for I:=1 to M do
 begin
  for J:=1 to N do
   begin
    C[(I-1)+(J-1)*4] := 0.0;
    for K:=1 to N do
     begin
      C[(I-1)+(J-1)*4] := C[(I-1)+(J-1)*4]+A[(I-1)+(K-1)*4]*B[(K-1)+(J-1)*4];
_6:
     end;
_7:
   end;
_8:
 end;
Result := Result + Format('%s',[' INVERSE(A)*A=']);
Result := Result + #$0D#$0A;
for J:=1 to N do
 begin
for I:=1 to M do
 begin
  Result := Result + Format('%20.12f ',[C[(I-1)+(J-1)*4]]) + #$0D#$0A;
 end;
 end;
Result := Result + #$0D#$0A;
UtRes('taig3r',Result);  {    taig3r.res}
exit;
end;

end.
